#include <afxwin.h>
#include "resource.h"

#define WM_ACTIVATESYSMENU   WM_APP+100

class CMyDlg: public CDialog
{
public:
	CMyDlg(CWnd* pParent) : CDialog(IDD_DLG, pParent) {}

	DECLARE_MESSAGE_MAP()

	BOOL OnInitDialog()
	{
		CMenu* pmenu = GetSystemMenu(FALSE);
		if (pmenu)
		{
			pmenu->AppendMenu(MF_SEPARATOR);
			pmenu->AppendMenu(MF_STRING, IDM_WEBSITE, _T("Website"));
		}
		PostMessage(WM_ACTIVATESYSMENU);
		return TRUE;
	}

	void OnWebSite()
	{
		ShellExecute( NULL, NULL, _T("http://www.codeguru.com"), NULL, NULL, 0 );
	}

	void OnSysCommand(UINT nID, LPARAM lParam)
	{
		switch (0xFF0 & nID)
		{
		case IDM_WEBSITE:
			OnWebSite();
			break;
		}

		CDialog::OnSysCommand(nID, lParam);
	}

	LRESULT OnActivateSysMenu(WPARAM wp, LPARAM lp)
	{
		keybd_event(VK_MENU, 0x38, 0, NULL);
		Sleep(40);
		keybd_event(VK_SPACE, 0x39, 0, NULL);
		Sleep(40);
		keybd_event(VK_SPACE, 0x39, KEYEVENTF_KEYUP, NULL);
		Sleep(40);
		keybd_event(VK_MENU, 0x38, KEYEVENTF_KEYUP, NULL);

		return 0;
	}
};

BEGIN_MESSAGE_MAP(CMyDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_MESSAGE(WM_ACTIVATESYSMENU, OnActivateSysMenu)
END_MESSAGE_MAP()

class CMainFrame: public CFrameWnd
{
	DECLARE_MESSAGE_MAP()

	BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pcx)
	{
		CMenu* pmenu = GetSystemMenu(FALSE);
		if (pmenu)
		{
			pmenu->AppendMenu(MF_SEPARATOR);
			pmenu->AppendMenu(MF_STRING, IDM_DLG, _T("Dialog"));
			pmenu->AppendMenu(MF_STRING, IDM_WEBSITE, _T("Website"));
		}
		PostMessage(WM_ACTIVATESYSMENU);
		return TRUE;
	}

	void OnWebSite()
	{
		ShellExecute( NULL, NULL, _T("http://www.codeguru.com"), NULL, NULL, 0 );
	}

	void OnDlg()
	{
		CMyDlg dlg(this);
		dlg.DoModal();
	}

	void OnSysCommand(UINT nID, LPARAM lParam)
	{
		switch (0xFF0 & nID)
		{
		case IDM_WEBSITE:
			OnWebSite();
			break;
		case IDM_DLG:
			OnDlg();
			break;
		}

		CFrameWnd::OnSysCommand(nID, lParam);
	}

	LRESULT OnActivateSysMenu(WPARAM wp, LPARAM lp)
	{
		keybd_event(VK_MENU, 0x38, 0, NULL);
		Sleep(40);
		keybd_event(VK_SPACE, 0x39, 0, NULL);
		Sleep(40);
		keybd_event(VK_SPACE, 0x39, KEYEVENTF_KEYUP, NULL);
		Sleep(40);
		keybd_event(VK_MENU, 0x38, KEYEVENTF_KEYUP, NULL);

		return 0;
	}
};

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_SYSCOMMAND()
	ON_MESSAGE(WM_ACTIVATESYSMENU, OnActivateSysMenu)
END_MESSAGE_MAP()

class CMyApp: public CWinApp
{
	BOOL InitInstance()
	{
		CMainFrame* pfr = new CMainFrame;
		m_pMainWnd = pfr;
		pfr->Create(NULL, TEXT("Frame"));
		pfr->ShowWindow(SW_SHOW);
		pfr->UpdateWindow();
		return TRUE;
	}
};

CMyApp theApp;